#!/usr/bin/tclsh

#Esko Arajrvi <edu@iki.fi>
#Read alpha-numeric words from the stdin, count appearing frequencies 
#of the words and print arbitrary number of highest frequency words 
#to the stdout.

set words [regexp -all -inline -- {[a-z0-9]+} [string tolower [read stdin]]]

foreach word $words {
    if {[info exists word_arr($word)]} {
        incr word_arr($word)
    } else {
        set word_arr($word) 1
    }
}

foreach {a b} [array get word_arr] {lappend results [list $a $b]}
set results [lsort -index 0 $results]
set results [lsort -index 1 -decreasing -integer $results]

puts [join [lrange $results 0 [expr [lindex $argv 0]-1]] "\n"]
