#!/usr/bin/python

"""Print the N most frequent words in input.

Lars Wirzenius <liw@iki.fi>"""

import string
import sys

N = int(sys.argv[1])

wordchars = string.ascii_letters + string.digits

fromchars = ""
tochars = ""
for code in range(256):
    fromch = chr(code)
    if fromch in wordchars:
    	toch = fromch
    else:
    	toch = " "
    fromchars = fromchars + fromch
    tochars = tochars + toch
table = string.maketrans(fromchars, tochars)

counts = {}
for line in sys.stdin.xreadlines():
    for word in line.translate(table).lower().split():
    	if counts.has_key(word):
	    counts[word] += 1
    	else:
	    counts[word] = 1

by_count = {}
for word in counts.keys():
    c = counts[word]
    if by_count.has_key(c):
    	by_count[c].append(word)
    else:
    	by_count[c] = [word]

keys = by_count.keys()
keys.sort()
keys.reverse()
for key in keys:
    by_count[key].sort()

list = []
while len(list) < N and keys:
    key = keys[0]
    list.append((key, by_count[key][0]))
    by_count[key] = by_count[key][1:]
    if by_count[key] == []:
    	keys = keys[1:]

for count, word in list:
    print count, word
