(* by Mike Furr <mfurr@debian.org> *)

open Printf

type word = {
  text: string;
  mutable count : int
}

let read_words tbl = 
  let lexbuf = Lexing.from_channel stdin in
  let num_words = ref 0 in
    try
      while true do
	let word = String.lowercase (Word_lexer.next lexbuf) in
	  try 
	    let current = Hashtbl.find tbl word in
	      current.count <- current.count + 1
	  with
	    | Not_found ->
		(Hashtbl.add tbl word {text=word; count = 1};
		 incr num_words
		)
      done; !num_words
    with
      | Word_lexer.EOF -> !num_words
	
	
let _ = 
  let print_num = int_of_string (Sys.argv.(1)) in
  let tbl = Hashtbl.create 127 in
  let num_words = read_words tbl in
  let list = ref [] in
    Hashtbl.iter 
      (fun x y ->
	 let rec helper list num =
	   if(num = 0) then []
	   else
	     match list with
	       | [] -> [y]
	       | hd::tl -> 
		   if(y.count > hd.count) then y :: list
		   else hd :: (helper tl (num-1))
	 in list := helper !list print_num
      ) tbl;
    let cur = ref print_num in
      List.iter (fun x -> if(!cur > 0) then (printf "%s %d\n" x.text x.count;decr cur)) !list;;
